/**
 * Copyright (c) 2012, Sergey Kambalin
 * All rights reserved.

 * ATTENTION: This commercial software is intended for use with Oxwall Free Community Software http://www.oxwall.org/
 * and is licensed under Oxwall Store Commercial License.
 * Full text of this license can be found at http://www.oxwall.org/store/oscl
 */

/**
 *
 * @author Sergey Kambalin <greyexpert@gmail.com>
 * @package hint.static
 */

HINT=(function(){var d,f={},b=7,a=null;d=$(".hint-container","#hint-prototype");var g,h,c;h=function(i){if(i){window.clearTimeout(i)}};c=function(j,i){return window.setTimeout(j,i)};g=function(j,i){j=j||function(){};i=i||window;return function(){return j.apply(i,arguments)}};f.start=function(){this.show()};f.stop=function(){this.hide()};f.enter=function(){h(this.timeouts.stop)};f.leave=function(){this.stop()};var e=function(i,j){this.hint=d.clone().hide();this.body=this.hint.find(".hint-body");this.topCornerBody=this.hint.find(".hint-top-corner-wrap .hint-corner");this.bottomCornerBody=this.hint.find(".hint-bottom-corner-wrap .hint-corner");this.rightCornerBody=this.hint.find(".hint-right-corner-wrap .hint-corner");this.visible=false;this._targetChanged=false;$("body").append(this.hint);this.orientationClass="hint-top-left";this.timeouts={start:null,stop:null,enter:null,leave:null};this.delegate={};if(i){this.setDelegate(i)}if(j){this.setTarget(j)}this.hint.on("mouseenter.hint",g(f.enter,this));this.hint.on("mouseleave.hint",g(f.leave,this));g(this.delegate.construct,this)()};e.prototype.START_TIMEOUT=700;e.prototype.STOP_TIMEOUT=200;e.prototype.SWITCH_TIMEOUT=400;e.prototype.setTarget=function(j){var i=this.target;this.target=$(j);this._targetChanged=true;this.target.data("hint",this);g(this.delegate.targetChange,this)(i);if(this.target.data("hint-zindex")){this.hint.css("z-index",this.target.data("hint-zindex"))}return this};e.prototype.setDelegate=function(i){this.delegate=i;return this};e.prototype.getDelegate=function(){return this.delegate};e.prototype.getSize=function(){return{width:this.hint.width(),height:this.hint.height()}};e.prototype.getPosition=function(i){var k,j;i=i||this.target;k=i.offset();j=$(window);if(!k){return null}return{top:k.top-j.scrollTop(),left:k.left-j.scrollLeft(),right:j.width()-k.left-j.scrollLeft(),bottom:j.height()+j.scrollTop()-k.top}};e.prototype.getOrientation=function(l){var i,k,j;l=l||this.target;k=this.getSize();i=this.getPosition(l);if(!i){return null}j={};j.top=k.height<i.top-b;j.bottom=!j.top;j.right=k.width<i.right;j.left=!j.right;return j};e.prototype.refreshOrientation=function(){var l,m,n,s,k,r,j,t,p,i,u,o,q;if(g(this.delegate.beforeRefreshOrientation,this)()===false){return this}if(!this.target){return this}o=this.target;this.target.addClass("hint-target");if(this.target.css("display")==="inline"){q=this.target.children().filter(function(){return $(this).is("img")||$(this).css("display")!=="inline"});if(q.length>0){this.target.addClass("hint-target-block");o=q.first()}}t=this.hint.find(".hint-top-corner-wrap");p=this.hint.find(".hint-bottom-corner-wrap");this.hint.removeClass(this.orientationClass);if(!this.delegate.refreshOrientation){n=o.outerHeight();s=o.outerWidth();l=g(this.delegate.getOffset,this)(o);l=l||o.offset();m={top:l.top+n,left:l.left};u=this.getSize();i=this.getOrientation(o);if(!i){return this}k=s/2-5;k=k<2?2:k;k=k>u.width/2?u.width/2:k;if(i.top&&i.left){this.orientationClass="hint-top-left";m.top=l.top-u.height-b;m.left=l.left-u.width+s;p.css("right",k);j=p}else{if(i.top&&i.right){this.orientationClass="hint-top-right";m.top=l.top-u.height-b;p.css("left",k);j=p}else{if(i.bottom&&i.left){this.orientationClass="hint-bottom-left";m.left=l.left-u.width+s;t.css("right",k);j=t}else{if(i.bottom&&i.right){this.orientationClass="hint-bottom-right";t.css("left",k);j=t}}}}this.hint.css(m)}else{j=g(this.delegate.refreshOrientation,this)(o)}this.hint.addClass(this.orientationClass);this.hint.removeClass("hint-invisible");if(j){r=j.position()}this._targetChanged=false;g(this.delegate.afterRefreshOrientation,this)(i,m,r,{width:s,height:n});return this};e.prototype.show=function(){if(this.visible){if(this._targetChanged){this.refreshOrientation()}return this}if(g(this.delegate.beforeShow,this)()===false){return this}if(!this.target){return this}this.hint.show();this.refreshOrientation();g(this.delegate.afterShow,this)();a=this;this.visible=true;return this};e.prototype.hide=function(){if(!this.visible){return this}if(g(this.delegate.beforeHide,this)()===false){return this}h(this.timeouts.stop);this.hint.hide();a=null;this.visible=false;g(this.delegate.afterHide,this)();return this};e.prototype.start=function(){g(this.delegate.beforeStart,this)();if(!this.target){return this}h(this.timeouts.stop);h(this.timeouts.start);this.timeouts.start=c(g(f.start,this),!!a?this.SWITCH_TIMEOUT:this.START_TIMEOUT);g(this.delegate.afterStart,this)();return this};e.prototype.stop=function(){g(this.delegate.beforeStop,this)();h(this.timeouts.start);h(this.timeouts.stop);this.timeouts.stop=c(g(f.stop,this),this.STOP_TIMEOUT);g(this.delegate.afterStop,this)();return this};e.prototype.setContent=function(i){this.body.empty().append(i);g(this.delegate.contentChange,this)();this.hint.addClass("hint-invisible");c(g(this.refreshOrientation,this),0);return this};e.prototype.setTopCorner=function(i){this.topCornerBody.empty().append(i);return this};e.prototype.setBottomCorner=function(i){this.bottomCornerBody.empty().append(i);return this};e.prototype.setRightCorner=function(i){this.rightCornerBody.empty().append(i);return this};return{createHint:function(i,j){if(!j){return new e(i)}var k=this.getHint(j);if(k){k.hide()}return new e(i,$(j))},getHint:function(i){var j=$(i);if(j.data("hint")){j.data("hint").setTarget(j);return j.data("hint")}return null},getHintOrCreate:function(i,j){var k=this.getHint(j);if(k){if(i){k.setDelegate(i)}return k}return this.createHint(i,j)},isAnyShown:function(){return !!a},getShown:function(){return a},init:function(){}}})();HINT.UTILS=(function(){var b={};var a;a=function(c){if(c.error){OW.error(c.error)}if(c.info){OW.info(c.info)}if(c.reload){window.location.reload()}if(c.redirect){window.location.href=c.redirect}};return{init:function(c){b=c},query:function(e,d,c){$.getJSON(b.queryRsp,{command:e,params:JSON.stringify(d)},function(f){if($.isFunction(c)){c(f)}a(f)})},toggleText:function(e,d,c){e=$(e);e.text(e.text()==d?c:d)}}})();HINT.Launcher=(function(){var a={},f=[],g={};var e,d;var b,c;c=function(j){var k;for(k=0;k<f.length;k++){var h=new RegExp(f[k]);if(h.test(j)){return true}}return false};b=function(i,j,h){$.getJSON(a.rsp,{url:i},function(n){if(!n||!n.markup){h();return}var l=n.markup;var p=l.content.body,m=$(p),o=null,k=null,q=null;if(!m.length){p="<span>"+p+"</span>";m=$(p)}k=l.content.bottomCorner?$(l.content.bottomCorner):"";o=l.content.topCorner?$(l.content.topCorner):"";q=l.content.rightCorner?$(l.content.rightCorner):"";j(m,o,k,q);OW.bindAutoClicks(m);OW.bindTips(m);if(l.styleSheets){$.each(l.styleSheets,function(r,s){OW.addCssFile(s)})}if(l.styleDeclarations){OW.addCss(l.styleDeclarations)}if(l.beforeIncludes){OW.addScript(l.beforeIncludes)}if(l.scriptFiles){OW.addScriptFiles(l.scriptFiles,function(){if(l.onloadScript){OW.addScript(l.onloadScript)}})}else{if(l.onloadScript){OW.addScript(l.onloadScript)}}})};e=function(h){this.url=h};e.prototype.construct=function(){var h=this;b(this.delegate.url,function(l,i,j,k){h.setContent(l);if(i){h.setTopCorner(i)}if(j){h.setBottomCorner(j)}if(k){h.setRightCorner(k)}},function(){this.stop()})};e.prototype.afterRefreshOrientation=function(j,h,i){if(i){this.topCornerBody.find(".uhint-corner-cover").css("margin-left",-(i.left+0.5))}};e.prototype.beforeShow=function(){var h=this;if(HINT.isAnyShown()&&HINT.getShown()!==this){HINT.getShown().hide()}if(OW.getActiveFloatBox()){this.hint.removeClass("hint-from-floatbox").addClass("hint-from-floatbox");OW.getActiveFloatBox().bind("close",function(){h.hint.removeClass("hint-from-floatbox");h.hide()})}};e.prototype.beforeStart=function(){if(HINT.isAnyShown()&&HINT.getShown().timeouts.stop){window.clearTimeout(HINT.getShown().timeouts.stop)}};e.prototype.beforeStop=function(){if(HINT.isAnyShown()&&HINT.getShown()!==this){HINT.getShown().stop()}};d=function(h){e.call(this,h);this.refreshOrientation=function(){var j,l,i={},k;this.orientationClass="hint-console-hint";k=this.target.parents(".ow_console_list_item:eq(0)");j=this.getSize();l=this.getPosition(k);if(!l){return null}i.top=l.top;i.left=l.left-j.width-12;this.hint.css(i)}};d.prototype=e.prototype;return{getHint:function(h){var j;var i=HINT.getHint(h);if(!i&&g[h.href]){i=g[h.href];i.setTarget(h)}if(i){j=$(h).is(".ow_console a")?d:e;i.setDelegate(new j(h.href))}return i},createHint:function(h){var j;j=$(h).is(".ow_console a")?d:e;var i=HINT.createHint(new j(h.href),h);g[h.href]=i;return i},init:function(k,j,l){var h=l.join(", ");a=k;f=j;HINT.init();var i;$(document).on("mouseenter.hint","a:not("+l.join(", ")+")",function(n){var m=this;if(!c(this.href)){return}var p=HINT.Launcher.getHint(this);if(p){p.start()}else{i=window.setTimeout(function(){HINT.Launcher.createHint(m).start()},HINT.isAnyShown()?50:150)}var o=$(n.target);if(o.data().tod){window.clearTimeout(o.data().tod)}});$(document).on("mouseleave.hint","a:not(.hint-container a)",function(){if(!c(this.href)){return}window.clearTimeout(i);var m=HINT.getHint(this);if(m){m.stop()}});$(document).on("click.hint","a:not(.hint-container a)",function(){if(!c(this.href)){return}var m=HINT.getHint(this);if(m){m.stop()}})}}})();